﻿; ===========================================================================================================
;:      ___   ________  ______    ______   ___      ___    _______   __    ___       _______   _______   
;      |"  | /"       )/" _  "\  /    " \ |"  \    /"  |  |   __ "\ |" \  |"  |     /"     "| /"      \  
;      ||  |(:   \___/(: ( \___)// ____  \ \   \  //   |  (. |__) :)||  | ||  |    (: ______)|:        | 
;      |:  | \___  \   \/ \    /  /    ) :)/\\  \/.    |  |:  ____/ |:  | |:  |     \/    |  |_____/   ) 
;   ___|  /   __/  \\  //  \ _(: (____/ //|: \.        |  (|  /     |.  |  \  |___  // ___)_  //      /  
;  /  :|_/ ) /" \   :)(:   _) \\        / |.  \    /:  | /|__/ \    /\  |\( \_|:  \(:      "||:  __   \  
; (_______/ (_______/  \_______)\"_____/  |___|\__/|___|(_______)  (__\_|_)\_______)\_______)|__|  \___) 
; ===========================================================================================================
; Library for simple usage of JS-Scripts in PureBasic

  IncludeFile "_Init.pb"
  IncludeFile "_IDLE.pb"
  
;::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  
  ;ScriptA with JQuery in it
  ScriptA$ = "var x=$('body');"
  ScriptA$ + "x.addClass('testClass');"
  ScriptA$ + "jsc_return(x.attr('class'));"
  
  ;ScriptB with simple use of arguments, Math and Strings
  ScriptB$ = "var x= args.name + 5*3*213*5.4+'_2secondscript_test2';"
  ScriptB$ + "jsc_return(x);"
  
  ;ScriptC with counter
  ScriptC$ = "window.setInterval('args.count++;" ;Every 300 secs new Output
  ScriptC$ + "jsc_return(args.count)',300);"
  
  ;ScriptD with Prompt and User-Data
  ScriptD$ = "jsc_return(prompt('Get from User','Default'));"
  
  ;Register Scripts
  JSc_Script("script_a", ScriptA$, "{'name':'test'}",1,1)
  JSc_Script("script_b", ScriptB$, "{'name':'test'}")
  JSc_Script("script_c", ScriptC$, "{'count':0}", 0)
  JSc_Script("script_d", ScriptD$, "{}")
  
  ;Run Scripts
  OpenConsole("JSC")

  While JSc_Script_Ready("script_a") <> 1 Or JSc_Script_Ready("script_b") <> 1  Or Val(JSc_Script_Out("script_c")) < 5
    JSc_IDLE()
    Delay(1)
    
    PrintN("a: "+JSc_Script_Out("script_a"))
    PrintN("b: "+JSc_Script_Out("script_b"))
    PrintN("c: "+JSc_Script_Out("script_c"))
    PrintN("d: "+JSc_Script_Out("script_d"))
    PrintN("======")
  Wend 

  
  ;Get Final-Results
  MessageRequester("Out", JSc_Script_Out("script_a")) ;Returns are in JSON_Format
  MessageRequester("Out", JSc_Script_Out("script_b"))
  MessageRequester("Out", JSc_Script_Out("script_c"))
  MessageRequester("Out", JSc_Script_Out("script_d"))
  
; =========================================================================================================== EOF
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 18
; FirstLine = 3
; EnableUnicode
; EnableXP
; Executable = test.exe
; DisableDebugger
; CompileSourceDirectory